# AVR Toolchain

## Prerequisites

```shell
apt install flex byacc bison build-essential apt install libgmp-dev libmpfr-dev libmpc-dev
```

## Binutils

```shell
$ wget http://ftp.gnu.org/gnu/binutils/binutils-2.33.1.tar.xz
$ tar xvf binutils-2.33.1.tar.xz
$ cd binutils-2.33.1
$ ./configure --target=avr --program-prefix="avr-"
$ make -j4
$ make install
```

## GCC

```shell
$ wget ftp://ftp.fu-berlin.de/unix/languages/gcc/releases/gcc-9.2.0/gcc-9.2.0.tar.xz
$ tar cvf gcc-9.2.0.tar.xz
$ mkdir avrgcc-9.2.0
$ cd avrgcc-9.2.0
$ ../gcc-9.2.0/configure --target=avr --enable-languages=c,c++ --disable-libssp
$ make -j4
$ make install
```

## avr-libc

```shell
$ wget http://download.savannah.gnu.org/releases/avr-libc/avr-libc-2.0.0.tar.bz2
$ tar xvf avr-libc-2.0.0.tar.bz2
$ cd avr-libc-2.0.0
$ ./configure --host=avr
$ make -j4
$ make install
```